summaryrefslogtreecommitdiffstats
path: root/source/a/device-mapper
diff options
context:
space:
mode:
Diffstat (limited to 'source/a/device-mapper')
-rw-r--r--source/a/device-mapper/64-device-mapper.rules37
-rwxr-xr-xsource/a/device-mapper/device-mapper.SlackBuild115
-rw-r--r--source/a/device-mapper/slack-desc20
3 files changed, 172 insertions, 0 deletions
diff --git a/source/a/device-mapper/64-device-mapper.rules b/source/a/device-mapper/64-device-mapper.rules
new file mode 100644
index 000000000..7e9a235db
--- /dev/null
+++ b/source/a/device-mapper/64-device-mapper.rules
@@ -0,0 +1,37 @@
+# device mapper links hook into "change" events, when the dm table
+# becomes available; some table-types must be ignored
+
+KERNEL=="device-mapper", NAME="mapper/control"
+
+KERNEL!="dm-*", GOTO="device_mapper_end"
+ACTION!="add|change", GOTO="device_mapper_end"
+
+# lookup device name
+# use dmsetup, until devmap_name is provided by sys-fs/device-mapper
+PROGRAM=="/sbin/dmsetup -j %M -m %m --noopencount --noheadings -c -o name info",
+ ENV{DM_NAME}="%c"
+
+# do not do anything if dmsetup does not provide a name
+ENV{DM_NAME}=="", NAME="", OPTIONS="ignore_device"
+
+# ignore luks crypt devices while not fully up
+ENV{DM_NAME}=="temporary-cryptsetup-*", NAME="", OPTIONS="ignore_device"
+
+# use queried name
+ENV{DM_NAME}=="?*", NAME="mapper/$env{DM_NAME}"
+
+SYMLINK+="disk/by-id/dm-name-$env{DM_NAME}"
+SYMLINK+="disk/by-name/$env{DM_NAME}"
+
+PROGRAM!="/sbin/dmsetup status -j %M -m %m", GOTO="device_mapper_end"
+ENV{DM_TYPE}="%c{3}"
+
+ENV{DM_TYPE}=="|*error*", GOTO="device_mapper_end"
+
+IMPORT{program}="vol_id --export $tempnode"
+OPTIONS="link_priority=50"
+ENV{DM_TYPE}=="*snapshot-origin*", OPTIONS="link_priority=60"
+ENV{ID_FS_USAGE}=="filesystem|other|crypto", ENV{ID_FS_UUID_ENC}=="?*", SYMLINK+="disk/by-uuid/$env{ID_FS_UUID_ENC}"
+ENV{ID_FS_USAGE}=="filesystem|other", ENV{ID_FS_LABEL_ENC}=="?*", SYMLINK+="disk/by-label/$env{ID_FS_LABEL_ENC}"
+
+LABEL="device_mapper_end"
diff --git a/source/a/device-mapper/device-mapper.SlackBuild b/source/a/device-mapper/device-mapper.SlackBuild
new file mode 100755
index 000000000..d770deed7
--- /dev/null
+++ b/source/a/device-mapper/device-mapper.SlackBuild
@@ -0,0 +1,115 @@
+#!/bin/sh
+
+# Copyright 2008, 2009 Patrick J. Volkerding, Sebeka, Minnesota, USA
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+VERSION=1.02.28
+ARCH=${ARCH:-x86_64}
+NUMJOBS=${NUMJOBS:-" -j7 "}
+BUILD=${BUILD:-1}
+
+CWD=$(pwd)
+TMP=${TMP:-/tmp}
+PKG=$TMP/package-device-mapper
+
+if [ "$ARCH" = "i486" ]; then
+ SLKCFLAGS="-O2 -march=i486 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "s390" ]; then
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+fi
+
+rm -rf $PKG
+mkdir -p $TMP $PKG
+cd $TMP
+rm -rf device-mapper.$VERSION
+tar xvf $CWD/device-mapper.$VERSION.tar.bz2 || exit 1
+cd device-mapper.$VERSION
+
+chown -R root.root .
+find . \
+ \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
+ -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
+ -exec chmod 644 {} \;
+
+CFLAGS="$SLKCFLAGS" \
+./configure \
+ --libdir=/lib${LIBDIRSUFFIX} \
+ --mandir=/usr/man \
+ --enable-static_link \
+ --enable-pkgconfig \
+ --enable-dmeventd \
+ --disable-selinux \
+ --with-device-uid=0 \
+ --with-device-gid=6 \
+ --with-device-mode=0660 \
+ --build=$ARCH-slackware-linux
+ # I tried adding --enable-compat but that failed to compile
+
+make $NUMJOBS || make || exit 1
+make install DESTDIR=$PKG || exit 1
+
+# On x86_64 the pkgconfig files are installed to the wrong directory, but
+# the .pc content is correct, so we just move them over:
+if [ ! -d $PKG/usr/lib${LIBDIRSUFFIX}/pkgconfig ]; then
+ mkdir -p $PKG/usr/lib${LIBDIRSUFFIX}
+ mv $PKG/usr/lib/pkgconfig $PKG/usr/lib${LIBDIRSUFFIX}/
+ rmdir $PKG/usr/lib || exit 1
+fi
+
+mkdir -p $PKG/lib/udev/rules.d
+cat $CWD/64-device-mapper.rules > $PKG/lib/udev/rules.d/64-device-mapper.rules
+
+( cd $PKG
+ find . | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+ find . | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
+)
+
+mkdir -p $PKG/usr/doc/device-mapper.$VERSION
+cp -a \
+ COPYING* INSTALL INTRO README* VERSION WHATS_NEW \
+ $PKG/usr/doc/device-mapper.$VERSION
+
+# Compress and if needed symlink the man pages:
+if [ -d $PKG/usr/man ]; then
+ ( cd $PKG/usr/man
+ for manpagedir in $(find . -type d -name "man*") ; do
+ ( cd $manpagedir
+ for eachpage in $( find . -type l -maxdepth 1) ; do
+ ln -s $( readlink $eachpage ).gz $eachpage.gz
+ rm $eachpage
+ done
+ gzip -9 *.?
+ )
+ done
+ )
+fi
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+makepkg -l y -c n $TMP/device-mapper-$VERSION-$ARCH-$BUILD.txz
+
diff --git a/source/a/device-mapper/slack-desc b/source/a/device-mapper/slack-desc
new file mode 100644
index 000000000..2708a39fb
--- /dev/null
+++ b/source/a/device-mapper/slack-desc
@@ -0,0 +1,20 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description. Line
+# up the first '|' above the ':' following the base package name, and the '|' on
+# the right side marks the last column you can put a character in. You must make
+# exactly 11 lines for the formatting to be correct. It's also customary to
+# leave one space after the ':'.
+
+ |-----handy-ruler------------------------------------------------------|
+device-mapper: device-mapper (device-mapper for logical volume management)
+device-mapper:
+device-mapper: The goal of device-mapper is to support volume management. The
+device-mapper: driver enables the definition of new block devices composed of
+device-mapper: ranges of sectors of existing devices. This can be used to define
+device-mapper: disk partitions or logical volumes.
+device-mapper:
+device-mapper: device-mapper is required by LVM2, the Logical Volume Manager.
+device-mapper:
+device-mapper:
+device-mapper:
+